petsc-3.4.2 2013-07-02

# MatZeroRowsColumns

Zeros all entries (except possibly the main diagonal) of a set of rows and columns of a matrix.

### Synopsis

    #include "petscmat.h"
    PetscErrorCode  MatZeroRowsColumns(Mat mat,PetscInt numRows,const PetscInt rows[],PetscScalar diag,Vec x,Vec b)

Collective on Mat

### Input Parameters

| mat | - the matrix
| numRows | - the number of rows to remove
| rows | - the global row indices
| diag | - value put in all diagonals of eliminated rows (0.0 will even eliminate diagonal entry)
| x | - optional vector of solutions for zeroed rows (other entries in vector are not used)
| b | - optional vector of right hand side, that will be adjusted by provided solution

### Notes

This does not change the nonzero structure of the matrix, it merely zeros those entries in the matrix.

The user can set a value in the diagonal entry (or for the AIJ and row formats can optionally remove the main diagonal entry from the nonzero structure as well, by passing 0.0 as the final argument).

For the parallel case, all processes that share the matrix (i.e., those in the communicator used for matrix creation) MUST call this routine, regardless of whether any rows being zeroed are owned by them.

Each processor can indicate any rows in the entire matrix to be zeroed (i.e. each process does NOT have to list only rows local to itself).

The option MAT_NO_OFF_PROC_ZERO_ROWS does not apply to this routine.

### See Also

MatZeroRowsIS(), MatZeroRowsStencil(), MatZeroEntries(), MatZeroRowsLocal(), MatSetOption(), MatZeroRowsColumnsIS()

Level:intermediate
Location:src/mat/interface/matrix.c
Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages